using System;
using System.Collections.Generic;
using System.Text;

namespace ObserverPattern_CascadeEvent
{
    public class Konto
    {
        public delegate void BeskedType(string besked, double belb, Konto konto);
        public event BeskedType SaldondretEvent;
        public event BeskedType IndsatEvent;
        public event BeskedType HvetEvent;

        private string navn;
        private double saldo;
        public Konto(string navn)
        {
            this.navn = navn;
            this.IndsatEvent = this.aktiverSaldondretEvent;// tilfj metode "vidresender" til SaldondretEvent observatrer
            this.HvetEvent = this.aktiverSaldondretEvent; // tilfj metode "vidresender" til SaldondretEvent observatrer
        }
        private void aktiverSaldondretEvent (string besked, double belb, Konto konto)
        {
            if (SaldondretEvent != null)            // test mindst n observatr
                SaldondretEvent(besked,belb , konto);   // udfr event metode(r)
        }

        public void Indst(double belb)
        {
            this.saldo = this.saldo + belb;
            IndsatEvent("Indsat", belb, this);   // udfr event metode(r) - test for eksistens nu overfldig da der mindst er egen metode

        }
        public void Hv(double belb)
        {
            this.saldo = this.saldo - belb;
            HvetEvent("Hvet", belb, this);   // udfr event metode(r) - test for eksistens nu overfldig da der mindst er egen metode
        }
        public string Navn
        {
            get { return this.navn; }
        }
        public double Saldo
        {
            get { return this.saldo; }
        }
        public override string ToString()
        {
            return "" + this.navn + ";" + this.saldo.ToString("F2");
        }

    }
}
